package org.brynhild.graduation.common.transfer.util;


import com.alibaba.fastjson.JSON;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.MediaType;

public class HttpEntityBuilder {

    private final HttpHeaders headers = new HttpHeaders();
    private String jsonStr = null;

    public HttpEntityBuilder addRequestBody(Object object) {
        headers.setContentType(MediaType.APPLICATION_JSON);
        headers.add("Accept", MediaType.APPLICATION_JSON.toString());
        jsonStr = JSON.toJSONString(object);
        return this;
    }

    public HttpEntityBuilder addHeader(String key, String value) {
        headers.set(key, value);
        return this;
    }

    public HttpEntity<String> build() {
        return new HttpEntity<>(jsonStr, headers);
    }
}
