package org.brynhild.graduation.common.utils;

import java.util.Random;

public class RandomCodeUtil {
    private static Random random;

    static {
        random = new Random();
    }

    public static void setRandom(Random newRandom) {
        random = newRandom;
    }

    public static String getRandomNumberCode() {
        return getRandomNumberCode(6);
    }

    public static String getRandomNumberCode(int length) {
        if (length < 0) {
            throw new IllegalArgumentException("length of random code must greater or equal to 1");
        }
        int min = (int) Math.pow(10, length - 1);
        int max = ((int) Math.pow(10, length) - 1);
        int code = random.nextInt(max);
        if (code < min) {
            code += min;
        }
        return code + "";
    }
}
