package org.brynhild.graduation.device;

import org.brynhild.graduation.common.utils.JwtUtil;
import org.brynhild.graduation.common.utils.RequestBodyVerifier;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.autoconfigure.domain.EntityScan;
import org.springframework.context.annotation.Bean;
import org.springframework.data.jpa.repository.config.EnableJpaRepositories;

@EntityScan(basePackages = {"org.brynhild.graduation.persistence"})
@EnableJpaRepositories(basePackages = {"org.brynhild.graduation.persistence"})
@SpringBootApplication
public class DeviceApplication {
    public static void main(String[] args) {
        SpringApplication.run(DeviceApplication.class, args);
    }


    @Bean
    public RequestBodyVerifier verifier() {
        return new RequestBodyVerifier();
    }

    @Bean
    public JwtUtil jwtUtil() {
        return new JwtUtil();
    }
}
