package org.brynhild.graduation.device.event

import jakarta.annotation.Resource
import org.brynhild.graduation.common.constant.RabbitQueueConstant
import org.brynhild.graduation.common.utils.ByteTransferUtil
import org.brynhild.graduation.persistence.log.entity.OperationLog
import org.brynhild.graduation.persistence.log.entity.SystemLog
import org.springframework.amqp.rabbit.core.RabbitTemplate
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.stereotype.Component

@Component
class LogSender {
    private RabbitTemplate rabbitTemplate

    void sendSystemLog(SystemLog log) {
        rabbitTemplate.convertAndSend(RabbitQueueConstant.SYSTEM_LOG, ByteTransferUtil.getBytesFromObject(log))
    }

    void sendOperationLog(OperationLog log) {
        rabbitTemplate.convertAndSend(RabbitQueueConstant.OPERATION_LOG, ByteTransferUtil.getBytesFromObject(log))
    }

    @Autowired
    @Resource
    void setRabbitTemplate(RabbitTemplate rabbitTemplate) {
        this.rabbitTemplate = rabbitTemplate
    }
}
