package org.brynhild.graduation.device.event;

import lombok.AllArgsConstructor;
import lombok.Data;
import org.brynhild.graduation.device.util.MqttUtil;
import org.eclipse.paho.client.mqttv3.MqttClient;
import org.eclipse.paho.client.mqttv3.MqttException;
import org.eclipse.paho.client.mqttv3.MqttMessage;
import org.eclipse.paho.client.mqttv3.persist.MemoryPersistence;

@AllArgsConstructor
@Data
public class MqttDeviceInstance {
    private final String macAddress;
    private final MqttClient client;
    private final MemoryPersistence persistence;

    public boolean sendMessage(MqttMessage message) {
        try {
            client.publish(MqttUtil.getServerPublish(macAddress), message);
            return true;
        } catch (MqttException me) {
            System.out.println("reason " + me.getReasonCode());
            System.out.println("msg " + me.getMessage());
            System.out.println("loc " + me.getLocalizedMessage());
            System.out.println("cause " + me.getCause());
            System.out.println("excep " + me);
            me.printStackTrace();
            return false;
        }
    }
}
