package org.brynhild.graduation.device.factory

import org.brynhild.graduation.persistence.device.entity.Device
import org.brynhild.graduation.persistence.log.entity.SystemLog
import org.springframework.stereotype.Component

@Component
class SystemLogFactory {

    private final String ln = "\r\n";

    SystemLog generateLogWithDeviceRegister(Device device, String origin, String newData) {
        SystemLog log = new SystemLog()
        return log.with {
            operatorId = device.id
            operatorName = device.name
            targetId = device.id
            targetName = device.name
            description = "设备：${device.id}-->${device.name}在${device.lastActive}上线"
            originData = origin
            it.newData = newData
            it
        }
    }
}
