package org.brynhild.graduation.persistence.common.entity;

import com.fasterxml.jackson.annotation.JsonIgnore;
import jakarta.persistence.*;
import lombok.Data;
import org.brynhild.graduation.common.utils.TimeUtil;

@MappedSuperclass
@Data
public class BaseEntity {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    @Column(name = "delete_at")
    private String deleteAt;
    @Version
    @JsonIgnore
    private Long version = 0L;

    @Column(name = "create_at")
    @JsonIgnore
    private String createAt = TimeUtil.getCurrentTimeString();

    @Column(name = "update_at")
    @JsonIgnore
    private String updateAt = TimeUtil.getCurrentTimeString();
}
