package org.brynhild.graduation.persistence.common.generator;

import org.hibernate.MappingException;
import org.hibernate.engine.spi.SharedSessionContractImplementor;
import org.hibernate.id.IdentityGenerator;
import org.springframework.stereotype.Component;

import java.io.Serializable;

@Component
public class UuidGenerator extends IdentityGenerator {
    @Override
    public Serializable generate(SharedSessionContractImplementor s, Object obj) throws MappingException {
        Serializable id = (Serializable) s.getEntityPersister(null, obj).getClassMetadata().getIdentifier(obj, s);
        if (id != null && Long.parseLong(id.toString()) > 0) {
            return id;
        } else {
            return (Serializable) super.generate(s, obj);
        }
    }
}