package org.brynhild.graduation.persistence.device.entity;

import jakarta.persistence.Entity;
import jakarta.persistence.Table;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import org.brynhild.graduation.common.tag.LogFieldDescription;
import org.brynhild.graduation.persistence.common.constant.CommonDBStringDefinition;
import org.brynhild.graduation.persistence.common.entity.LogicDeleteEntity;
import org.hibernate.annotations.Where;

import java.io.Serializable;

@EqualsAndHashCode(callSuper = true)
@Entity
@Table(name = "area")
@Data
@Where(clause = CommonDBStringDefinition.LOGIC_DELETE_WHERE_CLAUSE)
@NoArgsConstructor
public class Area extends LogicDeleteEntity implements Serializable {
    @LogFieldDescription("负责人")
    private Long owner;
    @LogFieldDescription("区域")
    private String name = "新建区域";
    @LogFieldDescription("备注信息")
    private String note;
}
