package org.brynhild.graduation.persistence.device.entity;

import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.Table;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import org.brynhild.graduation.common.tag.LogFieldDescription;
import org.brynhild.graduation.persistence.common.constant.CommonDBStringDefinition;
import org.brynhild.graduation.persistence.common.entity.LogicDeleteEntity;
import org.hibernate.annotations.Where;

import java.io.Serializable;

@EqualsAndHashCode(callSuper = true)
@Entity
@Table(name = "device")
@Data
@Where(clause = CommonDBStringDefinition.LOGIC_DELETE_WHERE_CLAUSE)
@NoArgsConstructor
public class Device extends LogicDeleteEntity implements Serializable {
    @LogFieldDescription("所有者")
    private Long owner;
    @LogFieldDescription("区域")
    private Long area;
    @LogFieldDescription("mac地址")
    private String mac;
    @LogFieldDescription("最后激活时间")
    @Column(name = "last_active")
    private String lastActive;

    @LogFieldDescription("设备名称")
    private String name = "新绑定设备";

    @LogFieldDescription("激活状态")
    private Boolean active = true;

    @LogFieldDescription("备注信息")
    private String note;

    @LogFieldDescription("设备类型")
    private Integer type;

    @LogFieldDescription("AP SSID")
    @Column(name = "ap_ssid")
    private String apSsid;
    @LogFieldDescription("AP PASSWORD")
    @Column(name = "ap_password")
    private String apPassword;
    @LogFieldDescription("STA SSID")
    @Column(name = "sta_ssid")
    private String staSsid;
    @LogFieldDescription("STA PASSWORD")
    @Column(name = "sta_password")
    private String staPassword;
}
