package org.brynhild.graduation.persistence.timetable.entity;

import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.Table;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import org.brynhild.graduation.common.tag.LogFieldDescription;
import org.brynhild.graduation.persistence.common.constant.CommonDBStringDefinition;
import org.brynhild.graduation.persistence.common.entity.LogicDeleteEntity;
import org.hibernate.annotations.Where;

import java.io.Serializable;

@Data
@Table(name = "timetable")
@Entity
@EqualsAndHashCode(callSuper = true)
@Where(clause = CommonDBStringDefinition.LOGIC_DELETE_WHERE_CLAUSE)
@NoArgsConstructor
public class TimeTable extends LogicDeleteEntity implements Serializable {
    @LogFieldDescription("区域i}d")
    @Column(name = "area_id")
    private Long areaId;
    @LogFieldDescription("时间点")
    private String index;
    @LogFieldDescription("周次")
    private String week;
    @LogFieldDescription("班级列表")
    private String clazz;
    @LogFieldDescription("课程id")
    @Column(name = "course_id")
    private Long courseId;
    @Column(name = "course_name")
    private String courseName;
    @LogFieldDescription("年份")
    private Integer year;
    @LogFieldDescription("学期")
    private Integer term;
}

