package org.brynhild.graduation.builder.event

import jakarta.annotation.Resource
import org.brynhild.graduation.common.constant.RabbitQueueConstant
import org.brynhild.graduation.common.utils.ByteTransferUtil
import org.brynhild.graduation.transfer.builder.BuildTaskResult
import org.springframework.amqp.rabbit.core.RabbitTemplate
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.stereotype.Component

@Component
class BuildEventResultSender {
    private RabbitTemplate rabbitTemplate

    void sendResult(BuildTaskResult result) {
        rabbitTemplate.convertAndSend(RabbitQueueConstant.BUILD_EVENT_RESULT, ByteTransferUtil.getBytesFromObject(result))
    }

    @Autowired
    @Resource
    void setRabbitTemplate(RabbitTemplate rabbitTemplate) {
        this.rabbitTemplate = rabbitTemplate
    }
}
