package org.brynhild.graduation.common.parser;

import org.brynhild.graduation.common.utils.TypeCastUtil;

import java.util.HashMap;
import java.util.Map;

public class StaticParser {
    public static Map<String, Parser> parserMap = new HashMap<>();

    public static Parser getParser(Class<?> type) {
        return parserMap.get(type.getName());
    }

    public static <T> T parse(Map<String, Object> obj, Class<T> type) {
        if (obj == null) {
            return null;
        }
        Parser parser = getParser(type);
        if (parser == null) {
            throw new IllegalArgumentException("Cannot find parser for:" + type.getName());
        }
        Object parse = parser.parse(obj);
        if (parse == null) {
            return null;
        }
        return TypeCastUtil.castToObject(parse, type);
    }
}
