package org.brynhild.graduation.common.parser.convertor;

import org.brynhild.graduation.common.tag.TypeConvertor;

@TypeConvertor
public final class DoubleConvertor implements BasicTypeConvertor {
    static Object getObject(Class<?> targetType, Object value) {
        if (value == null || targetType == null) {
            return null;
        }
        if (targetType.equals(Boolean.class)) {
            Boolean data = (Boolean) value;
            return data ? 1.0 : 0.0;
        }
        if (targetType.equals(boolean.class)) {
            boolean data = (boolean) value;
            return data ? 1.0 : 0.0;
        }

        if (targetType.equals(Byte.class)) {
            Byte data = (Byte) value;
            return data.doubleValue();
        }
        if (targetType.equals(byte.class)) {
            byte data = (byte) value;
            return new Byte(data).doubleValue();
        }

        if (targetType.equals(Double.class)) {
            return value;
        }
        if (targetType.equals(double.class)) {
            return value;
        }

        if (targetType.equals(Float.class)) {
            Float data = (Float) value;
            return data.doubleValue();
        }
        if (targetType.equals(float.class)) {
            float data = (float) value;
            return new Float(data).doubleValue();
        }

        if (targetType.equals(Integer.class)) {
            Integer data = (Integer) value;
            return data.doubleValue();
        }
        if (targetType.equals(int.class)) {
            int data = (int) value;
            return new Integer(data).doubleValue();
        }

        if (targetType.equals(Long.class)) {
            Long data = (Long) value;
            return data.doubleValue();
        }
        if (targetType.equals(long.class)) {
            long data = (long) value;
            return new Long(data).doubleValue();
        }

        if (targetType.equals(Short.class)) {
            Short data = (Short) value;
            return data.doubleValue();
        }
        if (targetType.equals(short.class)) {
            short data = (short) value;
            return new Short(data).doubleValue();
        }

        if (targetType.equals(String.class)) {
            return Double.parseDouble((String) value);
        }
        throw new IllegalArgumentException("Illegal Argument");
    }

    @Override
    public Object convert(Class<?> targetType, Object value) {
        return getObject(targetType, value);
    }
}
