package org.brynhild.graduation.common.parser.convertor;

import org.brynhild.graduation.common.tag.TypeConvertor;

@TypeConvertor
public final class LongConvertor implements BasicTypeConvertor {
    static Object getObject(Class<?> targetType, Object value) {
        if (value == null || targetType == null) {
            return null;
        }
        if (targetType.equals(Boolean.class)) {
            Boolean data = (Boolean) value;
            return data ? 1L : 0L;
        }
        if (targetType.equals(boolean.class)) {
            boolean data = (boolean) value;
            return data ? 1L : 0L;
        }

        if (targetType.equals(Byte.class)) {
            Byte data = (Byte) value;
            return data.longValue();
        }
        if (targetType.equals(byte.class)) {
            return value;
        }

        if (targetType.equals(Double.class)) {
            Double data = (Double) value;
            return data.longValue();
        }
        if (targetType.equals(double.class)) {
            double data = (double) value;
            return new Double(data).longValue();
        }

        if (targetType.equals(Float.class)) {
            Float data = (Float) value;
            return data.longValue();
        }
        if (targetType.equals(float.class)) {
            float data = (float) value;
            return new Float(data).longValue();
        }

        if (targetType.equals(Integer.class)) {
            Integer data = (Integer) value;
            return data.longValue();
        }
        if (targetType.equals(int.class)) {
            int data = (int) value;
            return new Integer(data).longValue();
        }

        if (targetType.equals(Long.class)) {
            return value;
        }
        if (targetType.equals(long.class)) {
            return value;
        }

        if (targetType.equals(Short.class)) {
            Short data = (Short) value;
            return data.longValue();
        }
        if (targetType.equals(short.class)) {
            return value;
        }

        if (targetType.equals(String.class)) {
            return Long.parseLong((String) value);
        }
        throw new IllegalArgumentException("Illegal Argument");
    }

    @Override
    public Object convert(Class<?> targetType, Object value) {
        return getObject(targetType, value);
    }
}
