package org.brynhild.graduation.common.utils;

import org.brynhild.graduation.common.transfer.dto.Result;
import org.springframework.stereotype.Component;
import org.springframework.validation.BindingResult;
import org.springframework.validation.ObjectError;

import java.util.List;

@Component
public class RequestBodyVerifier {

    public Result convertToErrors(BindingResult result) {
        StringBuilder builder = new StringBuilder();
        if (result.hasErrors()) {
            List<ObjectError> errorList = result.getAllErrors();
            for (ObjectError error : errorList) {
                builder.append(error.getDefaultMessage());
                builder.append(",");
            }
        }
        return new Result(false, "参数出错", builder.toString());
    }
}
