package org.brynhild.graduation.common.utils;

import java.util.Arrays;
import java.util.List;

public class StringUtil {
    private StringUtil() {

    }


    public static boolean isEmpty(String str) {
        return str == null || str.trim().length() == 0;
    }

    public static boolean anyMatch(String test, String[] dataSet) {
        return anyMatch(test, Arrays.asList(dataSet));
    }

    public static boolean anyMatch(String test, List<String> dataSet) {
        for (String str : dataSet) {
            if (str.equals(test)) {
                return true;
            }
        }
        return false;
    }

    public static String stripPrefix(String str, int count) {
        String[] groups = str.split("/");
        if (groups.length <= 1 + count) {
            return str;
        }
        StringBuilder tmp = new StringBuilder();
        for (int i = 1 + count; i < groups.length; i++) {
            tmp.append("/");
            tmp.append(groups[i]);
        }
        return tmp.toString();
    }

    public static String firstPrefix(String str) {
        String[] groups = str.split("/");
        if (groups.length <= 1) {
            return "";
        }
        return "/" + groups[1];
    }
}
