package org.brynhild.graduation.device.controller

import jakarta.annotation.Resource
import org.brynhild.graduation.common.transfer.dto.Result
import org.brynhild.graduation.common.utils.RequestBodyVerifier
import org.brynhild.graduation.device.service.IStudentService
import org.brynhild.graduation.transfer.device.vo.QuerySignInRecordRequest
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.validation.BindingResult
import org.springframework.validation.annotation.Validated
import org.springframework.web.bind.annotation.PostMapping
import org.springframework.web.bind.annotation.RequestBody
import org.springframework.web.bind.annotation.RequestMapping
import org.springframework.web.bind.annotation.RestController

@RestController
@RequestMapping("/student")
class StudentController {
    private IStudentService studentService
    private RequestBodyVerifier verifier

    @PostMapping("/signInRecord")
    Result findSignInRecord(@RequestBody @Validated QuerySignInRecordRequest request, BindingResult result) {
        if (result.hasErrors()) {
            return verifier.convertToErrors(result)
        }
        return studentService.findSignInRecord(request)
    }

    @Autowired
    @Resource
    void setStudentService(IStudentService studentService) {
        this.studentService = studentService
    }

    @Autowired
    @Resource
    void setVerifier(RequestBodyVerifier verifier) {
        this.verifier = verifier
    }
}
