package org.brynhild.graduation.device.service.impl

import jakarta.annotation.Resource
import org.brynhild.graduation.common.transfer.dto.Result
import org.brynhild.graduation.device.factory.SpecificationFactory
import org.brynhild.graduation.device.service.IStudentService
import org.brynhild.graduation.persistence.device.repository.SignInRecordRepository
import org.brynhild.graduation.transfer.device.vo.QuerySignInRecordRequest
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.stereotype.Component

@Component
class StudentServiceImpl implements IStudentService {
    private SpecificationFactory specificationFactory
    private SignInRecordRepository signInRecordRepository

    @Override
    Result findSignInRecord(QuerySignInRecordRequest request) {
        def specification = specificationFactory.getSignInRecordSpecification(request)
        println request
        return new Result(true, "查询成功", signInRecordRepository.findAll(specification))
    }

    @Autowired
    @Resource
    void setSpecificationFactory(SpecificationFactory specificationFactory) {
        this.specificationFactory = specificationFactory
    }

    @Autowired
    @Resource
    void setSignInRecordRepository(SignInRecordRepository signInRecordRepository) {
        this.signInRecordRepository = signInRecordRepository
    }
}
