package org.brynhild.graduation.device.util;

import lombok.RequiredArgsConstructor;
import org.brynhild.graduation.common.utils.JwtUtil;
import org.springframework.stereotype.Component;

@Component
@RequiredArgsConstructor
public class JwtValidator {

    private final JwtUtil jwtUtil;

    public boolean valid(String token) {
        try {
            this.jwtUtil.parseJWT(token);
            return true;
        } catch (Exception var3) {
            return false;
        }
    }

    public String getId(String token) {
        return this.jwtUtil.parseJWT(token).getId();
    }
}