package org.brynhild.graduation.device.util;


import static org.brynhild.graduation.common.constant.MqttConstant.FINAL;
import static org.brynhild.graduation.common.constant.MqttConstant.REGISTER_FINAL;

public class MqttUtil {
    private MqttUtil() {
    }

    public static String getServerListen(String macAddress) {
        return "send" + macAddress;
    }

    public static String getMacAddressFromTopic(String topic) {
        return topic.substring(4);
    }

    public static String getServerPublish(String macAddress) {
        return "rece" + macAddress;
    }

    public static String getDeviceMac(String message) {
        if (message.startsWith(REGISTER_FINAL)) {
            message = message.substring(REGISTER_FINAL.length());
        } else {
            throw new IllegalArgumentException("Cannot resolve macAddress:" + message);
        }
        if (message.length() != 17) {
            throw new IllegalArgumentException("Cannot resolve macAddress:" + message);
        }
        return message;
    }

    public static int getDeviceType(String message) {
        if (message.startsWith(REGISTER_FINAL)) {
            return FINAL;
        }
        throw new IllegalArgumentException("Cannot resolve device type:" + message);
    }
}
