package org.brynhild.graduation.event.service.impl


import org.brynhild.graduation.event.constant.EmailDefaultContent
import org.brynhild.graduation.event.constant.EmailTitleConstant
import org.brynhild.graduation.event.service.IEmailService
import org.brynhild.graduation.event.util.MailUtils
import org.brynhild.graduation.transfer.user.bo.SendActiveEmailEvent
import org.brynhild.graduation.transfer.user.bo.SendResetEmailEvent
import org.springframework.stereotype.Service

@Service
class EmailServiceImpl implements IEmailService {

    @Override
    void sendActiveEmail(SendActiveEmailEvent info) {
        String content = """
您正在注册账号或您更换了您的邮件地址，如是您本人操作，请点击右方链接进行激活
<a href="http://localhost:8080/#/user/active?code=${info.getHash()}" class="btn btn-danger">确认激活</a><br>
如非本人操作，请勿点击
"""
        println EmailDefaultContent.DEFAULT_CONTENT + content
        MailUtils.sendMail(info.address, EmailDefaultContent.DEFAULT_CONTENT + content, EmailTitleConstant.REGISTER)
    }

    @Override
    void sendResetEmail(SendResetEmailEvent info) {
        String content = """
您正在重置账号，如是您本人操作，请点击右方链接进行激活
<a href="http://localhost:8080/#/user/reset?code=${info.getHash()}" class="btn btn-danger">确认重置</a><br>
如非本人操作，请勿点击
"""
        println EmailDefaultContent.DEFAULT_CONTENT + content
        MailUtils.sendMail(info.address, EmailDefaultContent.DEFAULT_CONTENT + content, EmailTitleConstant.RESET)
    }
}
