package org.brynhild.graduation.event.service.impl


import jakarta.annotation.Resource
import org.brynhild.graduation.event.service.ILogService
import org.brynhild.graduation.persistence.log.entity.OperationLog
import org.brynhild.graduation.persistence.log.entity.SystemLog
import org.brynhild.graduation.persistence.log.repository.OperationLogRepository
import org.brynhild.graduation.persistence.log.repository.SystemLogRepository
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.stereotype.Service

@Service
class LogServiceImpl implements ILogService {
    private SystemLogRepository systemLogRepository
    private OperationLogRepository operationLogRepository

    @Override
    void addOperationLog(OperationLog operationLog) {
        operationLogRepository.save(operationLog)
    }

    @Override
    void addSystemLog(SystemLog systemLog) {
        systemLogRepository.save(systemLog)
    }


    @Autowired
    @Resource
    void setSystemLogRepository(SystemLogRepository systemLogRepository) {
        this.systemLogRepository = systemLogRepository
    }

    @Autowired
    @Resource
    void setOperationLogRepository(OperationLogRepository operationLogRepository) {
        this.operationLogRepository = operationLogRepository
    }
}
