package org.brynhild.graduation.file.controller;

import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import lombok.RequiredArgsConstructor;
import org.brynhild.graduation.common.transfer.dto.Result;
import org.brynhild.graduation.file.service.IFileService;
import org.springframework.http.HttpEntity;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

@RestController
@RequiredArgsConstructor
public class FileController {

    private final IFileService fileService;

    @PostMapping("/upload")
    public Result fileUpload(@RequestParam(value = "files") MultipartFile[] files, HttpServletRequest request) {
        return fileService.fileUpload(files, request);
    }

    @PostMapping("/upload/single")
    public Result singleFileUpload(@RequestParam(value = "file") MultipartFile file, HttpServletRequest request) {
        return fileService.singleFileUpload(file, request);
    }

    @PostMapping("/upload/single/sync")
    public Result singleFileUploadSync(@RequestParam(value = "file") MultipartFile file, HttpServletRequest request) {
        return fileService.singleFileUploadSync(file, request);
    }

    @GetMapping("/download/name/{name}")
    public HttpEntity<byte[]> fileDownloadByName(@PathVariable String name, HttpServletResponse response) {
        return fileService.fileDownloadByName(name, response);
    }

    @GetMapping("/download/id/{id}")
    public HttpEntity<byte[]> fileDownloadById(@PathVariable Long id, HttpServletResponse response) {
        return fileService.fileDownloadById(id, response);
    }

    @GetMapping("/info/{id}")
    public Result fileInfo(@PathVariable Long id) {
        return fileService.fileInfo(id);
    }
}
