package org.brynhild.graduation.gateway.rule


import org.springframework.http.server.reactive.ServerHttpRequest
import org.springframework.stereotype.Component
import org.springframework.web.server.ServerWebExchange

@Component
class PublicApiRule implements ApiRule {

    @Override
    boolean permit(ServerWebExchange exchange) {
        ServerHttpRequest request = exchange.getRequest()
        String path = request.getPath().toString()
        if (path.contains("/public/")) {
            return true
        }
        if (path.startsWith("/user/common/")) {
            return true
        }
        if (path.startsWith("/file/")) {
            return true
        }
        return false
    }
}
