package org.brynhild.graduation.gateway.rule

import jakarta.annotation.Resource
import org.brynhild.graduation.common.constant.AccountConstant
import org.brynhild.graduation.common.utils.JwtUtil
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.data.redis.core.RedisTemplate
import org.springframework.http.HttpHeaders
import org.springframework.http.server.reactive.ServerHttpRequest
import org.springframework.stereotype.Component
import org.springframework.web.server.ServerWebExchange

@Component
class TokenValidRule implements ApiRule {
    private JwtUtil jwtUtil

    private RedisTemplate<String, Object> redisTemplate

    private Map<String, String> userTokenMap = new HashMap<>()

    @Override
    boolean permit(ServerWebExchange exchange) {
        ServerHttpRequest request = exchange.getRequest()
        HttpHeaders headers = request.getHeaders()
        String token = headers.getFirst(AccountConstant.ACCOUNT_HEADER)
        if (token == null) {
            println "token not found"
            return false
        }
        println "token:${token}"
        try {
            String username = jwtUtil.parseJWT(token).get(AccountConstant.TOKEN_USERNAME, String.class)
            return true
//            TODO 没有保证全局唯一
//            String savedToken = userTokenMap.get(username)
//            println "savedToken:${savedToken}"
//            if (token == savedToken) {
//                return true
//            }
//            if (savedToken == null) {
//                Object tokenObject = redisTemplate.opsForValue().get(RedisConstant.USER_ACTIVE_TOKEN + username)
//                println "findTokenInRedis:${tokenObject}"
//                if (tokenObject instanceof String) {
//                    savedToken = tokenObject
//                    userTokenMap.put(username, tokenObject)
//                } else {
//                    return false
//                }
//            }
//            return savedToken.equals(token)
        } catch (Exception e) {
            e.printStackTrace()
            return false
        }
    }

    void notifyUserTokenChange(String username, String newToken) {
        userTokenMap.put(username, newToken)
    }

    void deleteUserToken(String username) {
        userTokenMap.remove(username)
    }

    @Autowired
    @Resource
    void setJwtUtil(JwtUtil jwtUtil) {
        this.jwtUtil = jwtUtil
    }

    @Autowired
    @Resource
    void setRedisTemplate(RedisTemplate<String, Object> redisTemplate) {
        this.redisTemplate = redisTemplate
    }
}
