package org.brynhild.graduation.gateway.rule.config

import org.brynhild.graduation.common.constant.AccountConstant
import org.brynhild.graduation.common.utils.StringUtil
import org.springframework.stereotype.Component

@Component
class AuthorityMap {
    boolean permit(String path, Integer userType) {
        def user = StringUtil.firstPrefix(path)
        return authorityMap.getOrDefault(user, new ArrayList<Integer>()).contains(userType)
    }

    private final Map<String, List<Integer>> authorityMap = new HashMap<String, List<Integer>>() {
        {
            put("/admin", Arrays.asList(AccountConstant.ADMIN))
            put("/student", Arrays.asList(AccountConstant.USER))
            put("/teacher", Arrays.asList(AccountConstant.TEACHER))
//        put("/system",AccountConstant.SYSTEM)
        }
    }
}
