package org.brynhild.graduation.persistence.device.entity;

import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.Table;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import org.brynhild.graduation.common.tag.LogFieldDescription;
import org.brynhild.graduation.persistence.common.constant.CommonDBStringDefinition;
import org.brynhild.graduation.persistence.common.entity.LogicDeleteEntity;
import org.hibernate.annotations.Where;

import java.io.Serializable;

@EqualsAndHashCode(callSuper = true)
@Entity
@Table(name = "device_relationship")
@Data
@Where(clause = CommonDBStringDefinition.LOGIC_DELETE_WHERE_CLAUSE)
@NoArgsConstructor
public class DeviceRelationship extends LogicDeleteEntity implements Serializable {
    @LogFieldDescription("主设备")
    private Long master;
    @LogFieldDescription("从设备")
    private Long slave;
    @Column(name = "master_type")

    @LogFieldDescription("主设备类型")
    private Integer masterType;
}
