package org.brynhild.graduation.persistence.device.entity;

import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.Table;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import org.brynhild.graduation.common.tag.LogFieldDescription;
import org.brynhild.graduation.common.utils.TimeUtil;
import org.brynhild.graduation.persistence.common.constant.CommonDBStringDefinition;
import org.brynhild.graduation.persistence.common.entity.LogicDeleteEntity;
import org.hibernate.annotations.Where;

import java.io.Serializable;

@EqualsAndHashCode(callSuper = true)
@Entity
@Table(name = "sign_in_record")
@Data
@Where(clause = CommonDBStringDefinition.LOGIC_DELETE_WHERE_CLAUSE)
@NoArgsConstructor
public class SignInRecord extends LogicDeleteEntity implements Serializable ,Comparable<SignInRecord>{
    @Column(name = "user_id")
    @LogFieldDescription("用户id")
    private Long userId;
    @Column(name = "area_id")
    @LogFieldDescription("区域id")
    private Long areaId;
    @Column(name = "device_id")
    @LogFieldDescription("设备id")
    private Long deviceId;
    @Column(name = "user_name")
    @LogFieldDescription("用户名")
    private String userName;
    @Column(name = "area_name")
    @LogFieldDescription("区域名称")
    private String areaName;
    @Column(name = "device_name")
    @LogFieldDescription("设备名称")
    private String deviceName;
    private String time = TimeUtil.getCurrentTimeString();

    @Override
    public int compareTo(SignInRecord o) {
        return o.getTime().compareTo(this.time);
    }
}
