package org.brynhild.graduation.persistence.device.repository

import org.brynhild.graduation.persistence.common.repository.LogicDeleteRepository
import org.brynhild.graduation.persistence.device.entity.SignInRecord
import org.springframework.stereotype.Repository

@Repository
interface SignInRecordRepository extends LogicDeleteRepository<SignInRecord> {

    List<SignInRecord> findSignInRecordByUserId(Long userId);

    List<SignInRecord> findSignInRecordByTimeBetweenAndAreaId(String startTime, String endTime, Long areaId)

    List<SignInRecord> findSignInRecordByTimeBetweenAndAreaIdAndUserId(String startTime, String endTime, Long areaId, Long userId)

}