package org.brynhild.graduation.persistence.timetable.entity;

import jakarta.persistence.Entity;
import jakarta.persistence.Table;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import org.brynhild.graduation.common.tag.LogFieldDescription;
import org.brynhild.graduation.persistence.common.constant.CommonDBStringDefinition;
import org.brynhild.graduation.persistence.common.entity.LogicDeleteEntity;
import org.hibernate.annotations.Where;

import java.io.Serializable;

@Data
@Table(name = "course")
@Entity
@EqualsAndHashCode(callSuper = true)
@Where(clause = CommonDBStringDefinition.LOGIC_DELETE_WHERE_CLAUSE)
@NoArgsConstructor
public class Course extends LogicDeleteEntity implements Serializable {
    @LogFieldDescription("课程名称")
    private String name;
    @LogFieldDescription("学分")
    private Double credit;
    @LogFieldDescription("开设学院")
    private Long department;
    @LogFieldDescription("课程类型")
    private Integer type;
    @LogFieldDescription("学时")
    private String period;
}
