package org.brynhild.graduation.persistence.timetable.repository

import org.brynhild.graduation.persistence.common.repository.LogicDeleteRepository
import org.brynhild.graduation.persistence.timetable.entity.TimeTable
import org.springframework.stereotype.Repository

@Repository
interface TimeTableRepository extends LogicDeleteRepository<TimeTable> {
    List<TimeTable> findTimeTableByClazzLike(String clazz);

//    @Query("select t from TimeTable t where t.pushed=? group by t.areaId")
    List<TimeTable> findTimeTableByPushed(Boolean pushed);

    List<TimeTable> findTimeTableByAreaIdAndWeekAndDayAndIndex(Long areaId, Integer week, Integer day, Integer index);

    List<TimeTable> findTimeTableByClazz(String clazz);

    List<TimeTable> findTimeTableByTeacher(Long teacher)

    List<TimeTable> findTimeTableByWeekAndDayAndIndexAndClazz(String week,Integer day,Integer index,String clazz)


}