package org.brynhild.graduation.persistence.user.entity;


import jakarta.persistence.Entity;
import jakarta.persistence.Table;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import org.brynhild.graduation.common.tag.LogFieldDescription;
import org.brynhild.graduation.persistence.common.constant.CommonDBStringDefinition;
import org.brynhild.graduation.persistence.common.entity.LogicDeleteEntity;
import org.hibernate.annotations.Where;

import java.io.Serializable;

@Data
@Table(name = "academy")
@Entity
@EqualsAndHashCode(callSuper = true)
@Where(clause = CommonDBStringDefinition.LOGIC_DELETE_WHERE_CLAUSE)
@NoArgsConstructor
public class Academy extends LogicDeleteEntity implements Serializable {
    @LogFieldDescription("学院名称")
    private String name;
    @LogFieldDescription("负责人用户id")
    private Long liable;
    @LogFieldDescription("图标")
    private String avatar;
    @LogFieldDescription("学院编号")
    private String no;
}
