package org.brynhild.graduation.persistence.user.entity;

import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.Table;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import org.brynhild.graduation.common.tag.LogFieldDescription;
import org.brynhild.graduation.persistence.common.constant.CommonDBStringDefinition;
import org.brynhild.graduation.persistence.common.entity.LogicDeleteEntity;
import org.hibernate.annotations.Where;

import java.io.Serializable;

@EqualsAndHashCode(callSuper = true)
@Entity
@Table(name = "class")
@Data
@Where(clause = CommonDBStringDefinition.LOGIC_DELETE_WHERE_CLAUSE)
@NoArgsConstructor
public class Class extends LogicDeleteEntity implements Serializable {
    @LogFieldDescription("班级号")
    private String no;
    @LogFieldDescription("学院id")
    @Column(name = "academy_id")
    private Long academyId;
    @LogFieldDescription("班级名称")
    private String name;
    @LogFieldDescription("专业id")
    @Column(name = "major_id")
    private Long majorId;
    @LogFieldDescription("学生数量")
    @Column(name = "student_num")
    private Integer studentNum = 0;

}
