package org.brynhild.graduation.timetable.controller;

import lombok.RequiredArgsConstructor;
import org.brynhild.graduation.common.transfer.dto.Result;
import org.brynhild.graduation.common.utils.RequestBodyVerifier;
import org.brynhild.graduation.timetable.service.ITimeTableService;
import org.brynhild.graduation.transfer.timetable.vo.QueryTimeTableRequest;
import org.springframework.validation.BindingResult;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RequestMapping("/student")
@RestController
@RequiredArgsConstructor
public class StudentController {
    private final RequestBodyVerifier verifier;
    private final ITimeTableService tableService;

    @PostMapping("/timetable")
    public Result queryStudentTimetable(@RequestBody @Validated QueryTimeTableRequest request, BindingResult result) {
        if (result.hasErrors()) {
            return verifier.convertToErrors(result);
        }
        return tableService.findTimeTable(request);
    }
}
