package org.brynhild.graduation.transfer.device.bo;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.brynhild.graduation.common.utils.ByteTransferUtil;

import java.io.Serializable;

@Data
@NoArgsConstructor
@AllArgsConstructor
public class SignInRecordBinary implements Serializable {
    private Integer uid;
    private String macAddress;

    public SignInRecordBinary(byte[] buffer) {
        byte[] idBuffer = new byte[4];
        System.arraycopy(buffer, 0, idBuffer, 0, 4);
        uid = ByteTransferUtil.byte2Int(idBuffer, true);
        macAddress = new String(buffer, 4, 17);
    }

    public byte[] convertToBytes() {
        byte[] buffer = new byte[24];
        System.arraycopy(ByteTransferUtil.int2Byte(uid, true), 0, buffer, 20, 4);
        System.arraycopy(macAddress.getBytes(), 0, buffer, 4, 17);
        return buffer;
    }
}
