package org.brynhild.graduation.transfer.device.bo;

import lombok.Data;
import org.brynhild.graduation.common.utils.ByteTransferUtil;
import org.brynhild.graduation.persistence.timetable.entity.TimeTable;

import java.io.Serializable;

@Data
public class TimeTableBinary implements Serializable {
    private Integer index;
    private Integer step;
    private Integer day;
    private Integer week;
    private String clazz;

    public TimeTableBinary(TimeTable table) {
        index = table.getIndex();
        step = table.getStep();
        day = table.getDay();
        clazz = table.getClazz();
    }

    public byte[] convertToBytes() {
        byte[] buffer = new byte[216];
        System.arraycopy(ByteTransferUtil.int2Byte(index, true), 0, buffer, 0, 4);
        System.arraycopy(ByteTransferUtil.int2Byte(step, true), 0, buffer, 4, 4);
        System.arraycopy(ByteTransferUtil.int2Byte(day, true), 0, buffer, 8, 4);
        System.arraycopy(ByteTransferUtil.int2Byte(week, true), 0, buffer, 12, 4);
        byte[] clazzBytes = clazz.getBytes();
        System.arraycopy(clazzBytes, 0, buffer, 16, Math.min(clazzBytes.length, 200));
        return buffer;
    }
}
