package org.brynhild.graduation.transfer.timetable.bo;

import lombok.Data;
import lombok.NoArgsConstructor;
import org.brynhild.graduation.persistence.timetable.entity.Course;

@Data
@NoArgsConstructor
public class CourseStatisticInfo implements Comparable<CourseStatisticInfo> {
    private Course course;
    private Long count;
    private Long actualCount;
    private Double rate;

    public CourseStatisticInfo(Course course, Long count, Long actualCount) {
        this.course = course;
        this.count = count;
        this.actualCount = actualCount;
        rate = 1.0 * actualCount / count;
    }

    @Override
    public int compareTo(CourseStatisticInfo o) {
        return rate.compareTo(o.rate);
    }
}
