package org.brynhild.graduation.trigger.event

import org.brynhild.graduation.common.constant.RabbitQueueConstant
import org.brynhild.graduation.common.utils.ByteTransferUtil
import org.brynhild.graduation.transfer.builder.BuildTaskResult
import org.springframework.amqp.rabbit.annotation.RabbitHandler
import org.springframework.amqp.rabbit.annotation.RabbitListener
import org.springframework.stereotype.Component


@Component
@RabbitListener(queues = RabbitQueueConstant.BUILD_EVENT_RESULT)
class BuildEventResultListener {

    @RabbitHandler
    void handleResult(byte[] bytes) {
        try {
            Object obj = ByteTransferUtil.getObjectFromBytes(bytes)
            switch (obj) {
                case BuildTaskResult:
                    println "Task(${obj.taskId}) finished with flag:${obj.flag}"
                    break
                default: throw new IllegalStateException("Unexpected value: " + obj)
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
