package org.brynhild.graduation.user.controller;

import lombok.RequiredArgsConstructor;
import org.brynhild.graduation.common.constant.AccountConstant;
import org.brynhild.graduation.common.transfer.dto.Result;
import org.brynhild.graduation.common.utils.RequestBodyVerifier;
import org.brynhild.graduation.transfer.user.vo.QueryUserRequest;
import org.brynhild.graduation.user.service.ITeacherService;
import org.springframework.validation.BindingResult;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

@RequestMapping("/teacher")
@RestController
@RequiredArgsConstructor
public class TeacherController {
    private final RequestBodyVerifier verifier;
    private final ITeacherService teacherService;

    @PostMapping("/user")
    public Result findUser(@RequestBody @Validated QueryUserRequest info, BindingResult result,
                           @RequestHeader(AccountConstant.ACCOUNT_HEADER) String token) {
        if (result.hasErrors()) {
            return verifier.convertToErrors(result);
        }
        return teacherService.findUser(info, token);
    }
}
