package org.brynhild.graduation.user.interceptor;


import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Component;
import org.springframework.web.method.HandlerMethod;
import org.springframework.web.servlet.AsyncHandlerInterceptor;

import java.lang.reflect.Method;


@Component
@RequiredArgsConstructor
public class AccessHandlerInterceptor implements AsyncHandlerInterceptor {
//    private final JwtUtil jwtUtil;

    @Override
    public boolean preHandle(HttpServletRequest request, HttpServletResponse response, Object handler) throws Exception {
        HandlerMethod handlerMethod = null;
        Method method = null;
        if (handler instanceof HandlerMethod) {
            handlerMethod = (HandlerMethod) handler;
            method = handlerMethod.getMethod();
        } else {
            return true;
        }
        String uri = request.getRequestURI();
        System.out.println(uri);
        if (uri.startsWith("/main")) {
            return true;
        }
        String token = request.getHeader("token");
        return token != null && uri.startsWith("/common");
    }
}
