package org.brynhild.graduation.user.service.impl

import jakarta.annotation.Resource
import org.brynhild.graduation.common.transfer.dto.Result
import org.brynhild.graduation.persistence.user.entity.User
import org.brynhild.graduation.persistence.user.repository.UserRepository
import org.brynhild.graduation.transfer.user.vo.QueryUserRequest
import org.brynhild.graduation.user.service.ITeacherService
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.stereotype.Service

@Service
class TeacherServiceImpl implements ITeacherService {
    private UserRepository userRepository

    @Override
    Result findUser(QueryUserRequest info, String token) {
        def userList = new ArrayList<User>()
        if (info.id != null) {
            def optional = userRepository.findById(info.id)
            if (optional.isPresent()) {
                userList.add(optional.get())
                return new Result(true, "查询成功", userList)
            } else {
                return new Result(false, "无相关用户")
            }
        }
        def specification = info.getSpecification()
        return new Result(true, "查询成功", userRepository.findAll(specification))
    }

    @Autowired
    @Resource
    void setUserRepository(UserRepository userRepository) {
        this.userRepository = userRepository
    }
}
