package org.brynhild.graduation.timetable.event

import jakarta.annotation.Resource
import org.brynhild.graduation.common.constant.RabbitQueueConstant
import org.brynhild.graduation.common.utils.ByteTransferUtil
import org.brynhild.graduation.common.utils.JwtUtil
import org.brynhild.graduation.persistence.log.entity.OperationLog
import org.brynhild.graduation.timetable.factory.OperationLogFactory
import org.springframework.amqp.rabbit.core.RabbitTemplate
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.stereotype.Component

@Component
class LogSender {
    private RabbitTemplate rabbitTemplate
    private OperationLogFactory operationLogFactory
    private JwtUtil jwtUtil

    void sendOperationLog(OperationLog log) {
        rabbitTemplate.convertAndSend(RabbitQueueConstant.OPERATION_LOG, ByteTransferUtil.getBytesFromObject(log))
    }

    @Autowired
    @Resource
    void setRabbitTemplate(RabbitTemplate rabbitTemplate) {
        this.rabbitTemplate = rabbitTemplate
    }

    @Autowired
    @Resource
    void setOperationLogFactory(OperationLogFactory operationLogFactory) {
        this.operationLogFactory = operationLogFactory
    }

    @Autowired
    @Resource
    void setJwtUtil(JwtUtil jwtUtil) {
        this.jwtUtil = jwtUtil
    }


}
