package org.brynhild.graduation.timetable.factory

import org.brynhild.graduation.persistence.log.entity.OperationLog
import org.brynhild.graduation.persistence.timetable.entity.Course
import org.brynhild.graduation.persistence.timetable.entity.TimeTable
import org.brynhild.graduation.transfer.timetable.vo.AdminAddCourse
import org.brynhild.graduation.transfer.timetable.vo.AdminAddTimeTable
import org.brynhild.graduation.transfer.timetable.vo.AdminModifyCourse
import org.brynhild.graduation.transfer.timetable.vo.AdminModifyTimeTable
import org.springframework.stereotype.Component

@Component
class OperationLogFactory {
    private final String ln = "\r\n";

    OperationLog generateLogWithAdminModifyCourse(AdminModifyCourse info, Course target) {
        def log = new OperationLog()
        def originData = target.toString()
        def builder = new StringBuilder()
        if (!StringUtil.isEmpty(info.name)) {
            builder.append("用户").append("修改了课程名称为： ").append(info.name).append(ln)
            target.name = info.name
        }
        if (info.credit != null) {
            builder.append("用户").append("修改了学分为： ").append(info.credit).append(ln)
            target.credit = info.credit
        }
        if (info.department != null) {
            builder.append("用户").append("修改了开设学院为： ").append(info.department).append(ln)
            target.department = info.department
        }
        if (info.type != null) {
            builder.append("用户").append("修改了课程类型为： ").append(info.type).append(ln)
            target.type = info.type
        }
        def newData = info.toString()
        log.originData = originData
        log.newData = newData
        log.description = builder.toString()
        log
    }


    OperationLog generateLogWithAdminModifyTimeTable(AdminModifyTimeTable info, TimeTable target) {
        def log = new OperationLog()
        def originData = target.toString()
        def builder = new StringBuilder()
        if (info.areaId != null) {
            builder.append("用户").append("修改了区域id为： ").append(info.areaId).append(ln)
            target.areaId = info.areaId
        }
        if (!StringUtil.isEmpty(info.index)) {
            builder.append("用户").append("修改了时间点为： ").append(info.index).append(ln)
            target.index = info.index
        }
        if (!StringUtil.isEmpty(info.week)) {
            builder.append("用户").append("修改了周次为： ").append(info.week).append(ln)
            target.week = info.week
        }
        if (!StringUtil.isEmpty(info.clazz)) {
            builder.append("用户").append("修改了班级列表为： ").append(info.clazz).append(ln)
            target.clazz = info.clazz
        }
        if (info.courseId != null) {
            builder.append("用户").append("修改了课程id为： ").append(info.courseId).append(ln)
            target.courseId = info.courseId
        }
        if (info.year != null) {
            builder.append("用户").append("修改了年份为： ").append(info.year).append(ln)
            target.year = info.year
        }
        if (info.term != null) {
            builder.append("用户").append("修改了学期为： ").append(info.term).append(ln)
            target.term = info.term
        }
        def newData = info.toString()
        log.originData = originData
        log.newData = newData
        log.description = builder.toString()
        log
    }


    OperationLog generateLogWithAdminAddTimeTable(AdminAddTimeTable info, TimeTable target) {
        def log = new OperationLog()
        def originData = target.toString()
        def builder = new StringBuilder()
        if (info.areaId != null) {
            builder.append("用户").append("修改了区域id为： ").append(info.areaId).append(ln)
            target.areaId = info.areaId
        }
        if (!StringUtil.isEmpty(info.index)) {
            builder.append("用户").append("修改了时间点为： ").append(info.index).append(ln)
            target.index = info.index
        }
        if (!StringUtil.isEmpty(info.week)) {
            builder.append("用户").append("修改了周次为： ").append(info.week).append(ln)
            target.week = info.week
        }
        if (!StringUtil.isEmpty(info.clazz)) {
            builder.append("用户").append("修改了班级列表为： ").append(info.clazz).append(ln)
            target.clazz = info.clazz
        }
        if (info.courseId != null) {
            builder.append("用户").append("修改了课程id为： ").append(info.courseId).append(ln)
            target.courseId = info.courseId
        }
        if (info.year != null) {
            builder.append("用户").append("修改了年份为： ").append(info.year).append(ln)
            target.year = info.year
        }
        if (info.term != null) {
            builder.append("用户").append("修改了学期为： ").append(info.term).append(ln)
            target.term = info.term
        }
        def newData = info.toString()
        log.originData = originData
        log.newData = newData
        log.description = builder.toString()
        log
    }


    OperationLog generateLogWithAdminAddCourse(AdminAddCourse info, Course target) {
        def log = new OperationLog()
        def originData = target.toString()
        def builder = new StringBuilder()
        if (!StringUtil.isEmpty(info.name)) {
            builder.append("用户").append("修改了课程名称为： ").append(info.name).append(ln)
            target.name = info.name
        }
        if (info.credit != null) {
            builder.append("用户").append("修改了学分为： ").append(info.credit).append(ln)
            target.credit = info.credit
        }
        if (info.department != null) {
            builder.append("用户").append("修改了开设学院为： ").append(info.department).append(ln)
            target.department = info.department
        }
        if (info.type != null) {
            builder.append("用户").append("修改了课程类型为： ").append(info.type).append(ln)
            target.type = info.type
        }
        def newData = info.toString()
        log.originData = originData
        log.newData = newData
        log.description = builder.toString()
        log
    }


}
