package org.brynhild.graduation.transfer.device.vo;

import lombok.Data;
import org.brynhild.graduation.common.tag.Actor;
import org.brynhild.graduation.common.tag.LogFieldIgnore;
import org.brynhild.graduation.common.tag.LogGenerated;
import org.brynhild.graduation.persistence.device.entity.Device;

import javax.validation.constraints.Max;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.PositiveOrZero;

@Data
@LogGenerated(Device.class)
@Actor("管理员")
public class BindDevice {
    @NotBlank
    @LogFieldIgnore
    private String code;
    @NotBlank
    private String mac;
    @NotNull
    @PositiveOrZero
    @Max(2)
    private Integer type;
    private Long area;
    private String note;
    private String name;
    private String apSsid;
    private String apPassword;
    @NotBlank
    private String staSsid;
    @NotBlank
    private String staPassword;

    @LogFieldIgnore
    private Long master;
}
