package org.brynhild.graduation.transfer.timetable.vo;

import lombok.Data;
import org.brynhild.graduation.common.tag.Actor;
import org.brynhild.graduation.common.tag.LogGenerated;
import org.brynhild.graduation.persistence.timetable.entity.Course;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Positive;
import javax.validation.constraints.PositiveOrZero;

@Data
@LogGenerated(Course.class)
@Actor
public class AdminAddCourse {
    @NotBlank
    private String name;
    @NotNull
    @Positive
    private Double credit;
    @Positive
    @NotNull
    private Long department;
    @PositiveOrZero
    @NotNull
    private Integer type;
}
