package org.brynhild.graduation.transfer.timetable.vo;

import lombok.Data;
import org.brynhild.graduation.common.tag.Actor;
import org.brynhild.graduation.common.tag.LogFieldIgnore;
import org.brynhild.graduation.common.tag.LogGenerated;
import org.brynhild.graduation.persistence.timetable.entity.TimeTable;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Positive;
import javax.validation.constraints.PositiveOrZero;

@Data
@LogGenerated(TimeTable.class)
@Actor
public class AdminModifyTimeTable {
    @Positive
    @NotNull
    @LogFieldIgnore
    private Long id;
    @Positive
    private Long areaId;
    @PositiveOrZero
    private String index;
    @NotBlank
    private String week;
    @NotBlank
    private String clazz;
    @Positive
    private Long courseId;
    @Positive
    private Integer year;
    @Positive
    private Integer term;
}
