package org.brynhild.graduation.trigger.event

import jakarta.annotation.Resource
import org.brynhild.graduation.common.constant.RabbitQueueConstant
import org.brynhild.graduation.common.utils.ByteTransferUtil
import org.brynhild.graduation.transfer.trigger.BuildTask
import org.springframework.amqp.rabbit.core.RabbitTemplate
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.stereotype.Component

@Component
class BuildEventSender {
    private RabbitTemplate rabbitTemplate


    void sendBuildTask(BuildTask task) {
        rabbitTemplate.convertAndSend(RabbitQueueConstant.BUILD_EVENT, ByteTransferUtil.getBytesFromObject(task))
    }

    @Autowired
    @Resource
    void setRabbitTemplate(RabbitTemplate rabbitTemplate) {
        this.rabbitTemplate = rabbitTemplate
    }
}
